name: createapp

on:
  workflow_dispatch:
    inputs:
      a_app_region:
        type: string
        description: "Application Region e.g. EU"
        default: EU
        required: true  
      b_app_flavor:
        type: string
        description: "Application Flavor e.g. EU.small"
        default: EU.small    
        required: true  
      c_cloudlet:
        type: choice
        options:
          - Amsterdam-OTC
          - Hamburg
          - Leipzig
          - Munich
          - Berlin
          - Frankfurt
          - Magdeburg-OTC
          - Bonn
          - Magdeburg
        description: "Cloudlet location"
        default: Munich
        required: true  

env:
  EDGEXR_PLATFORM_USERNAME: ${{ secrets.EDGEXR_PLATFORM_USERNAME }}
  EDGEXR_PLATFORM_PASSWORD: ${{ secrets.EDGEXR_PLATFORM_PASSWORD }}
  APP_REGION: ${{ inputs.a_app_region }}
  APP_FLAVOR: ${{ inputs.b_app_flavor }}
  CLOUDLET: ${{ inputs.c_cloudlet }}

jobs:
  build:
    runs-on: ubuntu-22.04

    steps:
      -
        name: Repository meta
        id: repository
        run: |
          registry=${{ github.server_url }}
          registry=${registry##http*://}
          echo "registry=${registry}" >> "$GITHUB_OUTPUT"
          echo "registry=${registry}"
          repository="$(echo "${{ github.repository }}" | tr '[:upper:]' '[:lower:]')"
          echo "repository=${repository}" >> "$GITHUB_OUTPUT"
          echo "repository=${repository}"
      -
        name: Docker meta
        uses: docker/metadata-action@v5
        id: docker
        with:
          images: ${{ steps.repository.outputs.registry }}/${{ steps.repository.outputs.repository }}
      - 
        name: Install Dependencies
        run: |
          sudo apt update
          sudo apt install -y curl jq
      -
        name: Create Edge Connect App
        run: |
          set -e
          echo login 
          EDGEXR_TOKEN="$(curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/login -H 'Content-Type: application/json' --data '{"password": "'${EDGEXR_PLATFORM_PASSWORD}'","username": "'${EDGEXR_PLATFORM_USERNAME}'"}' -sSf | jq -r .token)"

          CREATEAPP_JSON=$(cat <<EOF
          {
            "region": "${APP_REGION}",
            "app": {
              "key": {
                "organization": "edp-developer-framework",
                "name": "$(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')",
                "version": "${{ steps.docker.outputs.version }}"
              },
              "deployment": "kubernetes",
              "image_type": "Docker",
              "image_path": "${{ steps.repository.outputs.registry }}/${{ steps.repository.outputs.repository }}:${{ steps.docker.outputs.version }}",
              "allow_serverless": true,
              "defaultFlavor": {
                "name": "${APP_FLAVOR}"
              },
              "serverless_config": {},
              "deployment_generator": "kubernetes-basic", 
              "deployment_manifest": "apiVersion: v1\nkind: Service\nmetadata:\n  name: $(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')-tcp\n  labels:\n    run: $(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')\nspec:\n  type: LoadBalancer\n  ports:\n  - name: tcp80\n    protocol: TCP\n    port: 80\n    targetPort: 80\n  selector:\n    run: $(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')\n---\napiVersion: apps/v1\nkind: Deployment\nmetadata:\n  name: $(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')-deployment\nspec:\n  replicas: 1\n  selector:\n    matchLabels:\n      run: $(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')\n  template:\n    metadata:\n      labels:\n        run: $(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')\n        mexDeployGen: kubernetes-basic\n    spec:\n      volumes:\n      containers:\n      - name: $(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')\n        image: ${{ steps.repository.outputs.registry }}/${{ steps.repository.outputs.repository }}:${{ steps.docker.outputs.version }}\n        imagePullPolicy: Always\n        ports:\n        - containerPort: 80\n          protocol: TCP\n\n"
            }
          }
          EOF
          )

          echo $CREATEAPP_JSON

          echo create app
          curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/auth/ctrl/CreateApp -H 'Content-Type: application/json' -H "Authorization: Bearer $EDGEXR_TOKEN" -S --data "$CREATEAPP_JSON" --fail-with-body
      -
        name: Create Edge Connect App Instance
        run: |
          set -e
          EDGEXR_TOKEN="$(curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/login -H 'Content-Type: application/json' --data '{"password": "'${EDGEXR_PLATFORM_PASSWORD}'","username": "'${EDGEXR_PLATFORM_USERNAME}'"}' -sSf | jq -r .token)"

          CREATEAPPINSTANCE_JSON=$(cat <<EOF
          {
            "region": "${APP_REGION}",
            "appinst": {
              "key": {
                "organization": "edp-developer-framework",
                "name": "$(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')-instance",
                "cloudlet_key": {
                  "organization": "TelekomOP",
                  "name": "${CLOUDLET}"
                }
              },
              "app_key": {
                "organization": "edp-developer-framework",
                "name": "$(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')",
                "version": "${{ steps.docker.outputs.version }}"
              },
              "flavor": {
                "name": "${APP_FLAVOR}"
              }
            }
          }
          EOF
          )

          echo $CREATEAPPINSTANCE_JSON

          echo create app instance
          curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/auth/ctrl/CreateAppInst -H 'Content-Type: application/json' -H "Authorization: Bearer $EDGEXR_TOKEN" -S --data "$CREATEAPPINSTANCE_JSON" --fail-with-body
